/* ******************************************************************* *\
*                                types.d                                *
*                                                                       *
*                       Stewart's Utility Library                       *
*                                                                       *
*                              Version 0.10                             *
*                                                                       *
*                      Type manipulation templates                      *
>***********************************************************************<
* Copyright (C) 2012 Stewart Gordon.                                    *
*                                                                       *
* This software is provided 'as-is', without any express or implied     *
* warranty.  In no event will the author be held liable for any damages *
* arising from the use of this software.                                *
*                                                                       *
* Permission is granted to anyone to use this software for any purpose, *
* including commercial applications, and to alter it and redistribute   *
* it freely, subject to the following restrictions:                     *
*                                                                       *
* - The origin of this software must not be misrepresented; you must    *
*   not claim that you wrote the original software.  If you use this    *
*   software in a product, an acknowledgment in the product             *
*   documentation would be appreciated but is not required.             *
* - Altered source versions must be plainly marked as such, and must    *
*   not be misrepresented as being the original software.               *
* - This notice may not be removed or altered from any source           *
*   distribution.                                                       *
*                                                                       *
* For updates, documentation and other information related to this      *
* product, visit http://pr.stewartsplace.org.uk/d/sutil/.               *
* Email me with comments/suggestions/bug reports: smjg@iname.com        *
\* ******************************************************************* */
/**
This module contains templates used to test properties of types.

Since: 0.10
Future_Directions:
	If a case arises for type-construction templates, these will also be placed here.
*/
module smjg.libs.util.types;

///
template isConst(T) {
	enum bool isConst = is(T == const(T));
}

///
template isImmutable(T) {
	enum bool isImmutable = is(T == immutable(T));
}

///
template isTailConst(T) {
	enum bool isTailConst = is(const(T) : T);
}

///
template isTailImmutable(T) {
	enum bool isTailImmutable = is(T : immutable(T)) && is(immutable(T) : T);
}
